<?php
session_start();
/*
You MUST edit this line, you have to add your HLDS IPs (could be one or more). If you don't php won't save anything.
*/
$serverIP = Array("127.0.0.1", "192.168.0.100");

$MySQL_host = "localhost";
$MySQL_username = "";
$MySQL_password = "";
$MySQL_database = "";

$serverIP = portCleaner($serverIP);

if (!isset($_SESSION['flood'])){
	$_SESSION['flood'] = 1;
	$_SESSION['time'] = time();
} else {
	$_SESSION['flood']++;
}
if ($_SESSION['time']+2 <= time()){
	$_SESSION['flood'] = 0;
	$_SESSION['time'] = time();
}
function portCleaner($arr){
	$temp = Array();
	foreach ($arr as $data){
		$parse = explode(":", $data);
		$temp[] = str_replace(" ", "", $parse[0]);
	}
	return $temp;
}
function cleaner($str){
	$str = str_replace("<", "&lt;", $str);
	$str = str_replace(">", "&gt;", $str);
	$str = str_replace("&", "&amp;", $str);
	return $str;
}
if ($_SESSION['flood'] > 5){
	echo "Flood detected";
	exit;
}
$mysqli = new mysqli($MySQL_host, $MySQL_username, $MySQL_password, $MySQL_database);
if ($mysqli->connect_errno){
    echo "MySQL connection error: (".$mysqli->connect_errno.") ".$mysqli->connect_error;
	exit;
}
if (isset($_POST['name']) && in_array($_SERVER['REMOTE_ADDR'], $serverIP)){
	$pj = cleaner($_POST['name']);
	$msg = cleaner($_POST['msg']);
	$ip = cleaner($_POST['ip']);
	$alive = $_POST['alive']*1;
	$stmt = $mysqli->prepare("INSERT INTO cs_chat (pj, msg, alive, ip) VALUES (?,?,?,?)");
	$stmt->bind_param("ssis", $pj, $msg, $alive, $ip);
	$stmt->execute();
	$stmt->close();
} else {
	if (isset($_GET['ip'])){
		$ip = "%".cleaner($_GET['ip'])."%";
		$stmt = $mysqli->prepare("SELECT id, pj, alive, msg, date FROM cs_chat WHERE ip LIKE ? ORDER BY id DESC LIMIT 10");
		$stmt->bind_param("s", $ip);
	} else {
		$stmt = $mysqli->prepare("SELECT id, pj, alive, msg, date FROM cs_chat ORDER BY id DESC LIMIT 10");
	}
	$stmt->execute();
	$stmt->bind_result($id, $pj, $alive, $msg, $fecha);
	$Atemp = Array();
	while ($stmt->fetch()){
		$Atemp[] = Array($id, $pj, $alive, $msg, $fecha);
	}
	krsort($Atemp);
	$Amessages = Array();
	foreach ($Atemp as $msg){
		$Amessages[] = $msg;
	}
	echo json_encode($Amessages);
	$stmt->close();
}
?>
